diff a/src/hotspot/share/gc/serial/tenuredGeneration.cpp b/src/hotspot/share/gc/serial/tenuredGeneration.cpp
--- a/src/hotspot/share/gc/serial/tenuredGeneration.cpp
+++ b/src/hotspot/share/gc/serial/tenuredGeneration.cpp
@@ -389,11 +389,11 @@
 
   return res;
 }
 
 oop TenuredGeneration::allocate_for_promotion(oop obj, size_t obj_size) {
-  assert(obj_size == obj->size(), "bad obj_size passed in");
+  assert(obj_size == obj->size() || UseCompactObjectHeaders, "bad obj_size passed in");
 
 #ifndef PRODUCT
   if (SerialHeap::heap()->promotion_should_fail()) {
     return nullptr;
   }
